
AC_DEFUN(LAC_DUROC_ARGS,
[

dnl check for submodule enable args
dnl order is unimportant

lac_enable_duroc_common="no"

AC_ARG_ENABLE(duroc-debug,
        [  --enable-duroc-debug           enable DUROC debug messages],
        [lac_enable_duroc_debug="$enableval"],
        [lac_enable_duroc_debug="no"])
AC_ARG_ENABLE(duroc-warnings,
        [  --disable-duroc-warnings       disable DUROC warning messages],
        [lac_enable_duroc_warnings="$enableval"],
        [lac_enable_duroc_warnings="yes"])
AC_ARG_ENABLE(duroc-control,
        [  --enable-duroc-control         configure DUROC control library],
        [lac_enable_duroc_control="$enableval"],
        [lac_enable_duroc_control="no"])
AC_ARG_ENABLE(duroc-runtime,
        [  --enable-duroc-runtime         configure DUROC runtime library],
        [lac_enable_duroc_runtime="$enableval"],
        [lac_enable_duroc_runtime="no"])
AC_ARG_ENABLE(duroc-bootstrap,
        [  --enable-duroc-bootstrap       configure DUROC bootstrap library],
        [lac_enable_duroc_bootstrap="$enableval"],
        [lac_enable_duroc_bootstrap="no"])
AC_ARG_ENABLE(duroc-test,
        [  --enable-duroc-test            configure DUROC test],
        [lac_enable_duroc_test="$enableval"],
        [lac_enable_duroc_test="no"])
AC_ARG_ENABLE(duroc-test-app,
        [  --enable-duroc-test-app        configure DUROC test-app],
        [lac_enable_duroc_test_app="$enableval"],
        [lac_enable_duroc_test_app="no"])
AC_ARG_ENABLE(duroc-tools,
        [  --enable-duroc-tools           configure DUROC tools],
        [lac_enable_duroc_tools="$enableval"],
        [lac_enable_duroc_tools="no"])

])

AC_DEFUN(LAC_DUROC,
[

LAC_DUROC_ARGS

duroc_debug_flag=""

if test "$lac_enable_duroc_debug" = "yes" ; then
    duroc_debug_flag="-DDUROC_DEBUG"
fi

if test "$lac_enable_duroc_warnings" = "yes" ; then
    duroc_debug_flag="-DDUROC_VERBOSE_AT_ERROR $duroc_debug_flag"
fi

AC_SUBST(duroc_debug_flag)

dnl perform dependency-based enables
dnl sorted by submodule dependency to be sure everything is expanded
 
lac_enable_duroc_common="no"

if test "$lac_enable_duroc_test" = "yes" ; then
    lac_enable_duroc_control="yes"
fi
if test "$lac_enable_duroc_tools" = "yes" ; then
    lac_enable_duroc_control="yes"
fi
if test "$lac_enable_duroc_test_app" = "yes" ; then
    lac_enable_duroc_runtime="yes"
    lac_enable_duroc_bootstrap="yes"
fi

if test "$lac_enable_duroc_bootstrap" = "yes" ; then
    lac_enable_duroc_runtime="yes"
    lac_enable_duroc_common="yes"
fi

if test "$lac_enable_duroc_control" = "yes" ; then
    lac_enable_duroc_common="yes"
fi
if test "$lac_enable_duroc_runtime" = "yes" ; then
    lac_enable_duroc_common="yes"
fi

])

