
AC_DEFUN(LAC_GRAM_ARGS,
[

AC_ARG_ENABLE(gram-client,
        [  --disable-gram-client         don't configure GRAM client library],
        [lac_enable_gram_client="$enableval"],
        [lac_enable_gram_client="yes"])

AC_ARG_ENABLE(gram-rsl,
        [  --disable-gram-rsl            don't configure GRAM resource spec language library],
        [lac_enable_gram_rsl="$enableval"],
        [lac_enable_gram_rsl="yes"])

AC_ARG_ENABLE(gram-myjob,
        [  --disable-gram-myjob          don't configure GRAM myjob library],
        [lac_enable_gram_myjob="$enableval"],
        [lac_enable_gram_myjob="yes"])

AC_ARG_ENABLE(gram-gatekeeper,
        [  --disable-gram-gatekeeper     don't configure GRAM gatekeeper],
        [lac_enable_gram_gatekeeper="$enableval"],
        [lac_enable_gram_gatekeeper="yes"])

AC_ARG_ENABLE(gram-duct-control,
        [  --disable-gram-duct-control   don't configure GRAM DUCT control library],
	[lac_enable_gram_duct_control="$enableval"],
	[lac_enable_gram_duct_control="yes"])

AC_ARG_ENABLE(gram-duct-runtime,
        [  --disable-gram-duct-runtime   don't configure GRAM DUCT runtime library],
	[lac_enable_gram_duct_runtime="$enableval"],
	[lac_enable_gram_duct_runtime="yes"])

AC_ARG_WITH(gram-job-manager,
	[  --with-gram-job-manager       GRAM job manager: condor, easymcs, lsf, loadleveler, or fork [fork]],
	[if test "$withval" = "yes" ; then
	     lac_gram_jm_type="fork"
         else
             lac_gram_jm_type="$withval"
         fi
        ],
	[lac_gram_jm_type="fork"])


AC_ARG_WITH(gram-port,
       [  --with-gram-port              port number of the gatekeeper [754]],
       [lac_gram_port="$withval"],
       [lac_gram_port="754"])


AC_ARG_ENABLE(gram-test,
        [  --disable-gram-test           don't configure GRAM test],
        [lac_enable_gram_test="$enableval"],
        [lac_enable_gram_test="yes"])

])

AC_DEFUN(LAC_GRAM_MYJOB,
[
    if test "$lac_mpl" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_mpl.\$(OFILE)"
    elif test "$lac_mpi" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_mpi.\$(OFILE)"
    else
        case "$target" in
            i860-intel-osf* )
                GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_inx.\$(OFILE)"
	    ;;

	    * )
                GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_none.\$(OFILE)"
	    ;;		
	esac
    fi
    AC_SUBST(GRAM_MYJOB_SHARED_PROTO_OBJS)
])

AC_DEFUN(LAC_GRAM,
[
    LAC_GRAM_ARGS

    case "$lac_gram_jm_type" in
        condor )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=condor
            GRAM_JM_SHELL_DEFINE=-DGRAMI_CONDOR_MANAGER
        ;;
        easymcs )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=easymcs
            GRAM_JM_SHELL_DEFINE=-DGRAMI_EASYMCS_MANAGER
        ;;
        loadleveler )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=loadleveler
            GRAM_JM_SHELL_DEFINE=-DGRAMI_LOADLEVELER_MANAGER
        ;;
        t3e_nqe )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=t3e_nqe
            GRAM_JM_SHELL_DEFINE=-DGRAMI_T3E_NQE_MANAGER
        ;;
        lsf )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=lsf
            GRAM_JM_SHELL_DEFINE=-DGRAMI_LSF_MANAGER
        ;;
        fork )
            GRAM_JM_METHOD=grami_jm_simple_fork
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
        fake )
            GRAM_JM_METHOD=grami_jm_fake
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
	no )
	;;
        * )
            AC_MSG_ERROR([Invalid --with-gram-job-manager value: $lac_gram_jm_type])
        ;;
    esac
    
    GRAM_JM_TYPE=$lac_gram_jm_type

    AC_SUBST(GRAM_JM_TYPE)
    AC_SUBST(GRAM_JM_METHOD)
    AC_SUBST(GRAM_JM_SHELL_TYPE)
    AC_SUBST(GRAM_JM_SHELL_DEFINE)

    dnl Assign all of the GRAM_ERROR values
    GRAM_SUCCESS=0
    GRAM_ERROR_PARAMETER_NOT_SUPPORTED=1
    GRAM_ERROR_INVALID_REQUEST=2
    GRAM_ERROR_NO_RESOURCES=3
    GRAM_ERROR_BAD_DIRECTORY=4
    GRAM_ERROR_BAD_EXECUTABLE=5
    GRAM_ERROR_INSUFFICIENT_FUNDS=6
    GRAM_ERROR_AUTHORIZATION=7
    GRAM_ERROR_USER_CANCELLED=8
    GRAM_ERROR_SYSTEM_CANCELLED=9
    GRAM_ERROR_PROTOCOL_FAILED=10
    GRAM_ERROR_STDIN_NOTFOUND=11
    GRAM_ERROR_CONNECTION_FAILED=12
    GRAM_ERROR_INVALID_MAXTIME=13
    GRAM_ERROR_INVALID_COUNT=14
    GRAM_ERROR_NULL_SPECIFICATION_TREE=15
    GRAM_ERROR_JM_FAILED_ALLOW_ATTACH=16
    GRAM_ERROR_JOB_EXECUTION_FAILED=17
    GRAM_ERROR_INVALID_PARADYN=18
    GRAM_ERROR_INVALID_JOBTYPE=19
    GRAM_ERROR_INVALID_MYJOB=20
    GRAM_ERROR_BAD_SCRIPT_ARG_FILE=21
    GRAM_ERROR_ARG_FILE_CREATION_FAILED=22
    GRAM_ERROR_INVALID_JOBSTATE=23
    GRAM_ERROR_INVALID_SCRIPT_REPLY=24
    GRAM_ERROR_INVALID_SCRIPT_STATUS=25
    GRAM_ERROR_MPI_NOT_SUPPORTED=26
    GRAM_ERROR_UNIMPLEMENTED=27
    GRAM_ERROR_TEMP_SCRIPT_FILE_FAILED=28
    GRAM_ERROR_PROXY_FILE_RELOCATION_FAILED=29
    GRAM_ERROR_PROXY_FILE_OPEN_FAILED=30
    GRAM_ERROR_JOB_CANCEL_FAILED=31

    dnl Add new GRAM_ERROR codes here, and set GRAM_ERROR_LAST to be
    dnl one higher than the last error code
    GRAM_ERROR_LAST=32

    AC_SUBST(GRAM_SUCCESS)
    AC_SUBST(GRAM_ERROR_PARAMETER_NOT_SUPPORTED)
    AC_SUBST(GRAM_ERROR_INVALID_REQUEST)
    AC_SUBST(GRAM_ERROR_NO_RESOURCES)
    AC_SUBST(GRAM_ERROR_BAD_DIRECTORY)
    AC_SUBST(GRAM_ERROR_BAD_EXECUTABLE)
    AC_SUBST(GRAM_ERROR_INSUFFICIENT_FUNDS)
    AC_SUBST(GRAM_ERROR_AUTHORIZATION)
    AC_SUBST(GRAM_ERROR_USER_CANCELLED)
    AC_SUBST(GRAM_ERROR_SYSTEM_CANCELLED)
    AC_SUBST(GRAM_ERROR_PROTOCOL_FAILED)
    AC_SUBST(GRAM_ERROR_STDIN_NOTFOUND)
    AC_SUBST(GRAM_ERROR_CONNECTION_FAILED)
    AC_SUBST(GRAM_ERROR_INVALID_MAXTIME)
    AC_SUBST(GRAM_ERROR_INVALID_COUNT)
    AC_SUBST(GRAM_ERROR_NULL_SPECIFICATION_TREE)
    AC_SUBST(GRAM_ERROR_JM_FAILED_ALLOW_ATTACH)
    AC_SUBST(GRAM_ERROR_JOB_EXECUTION_FAILED)
    AC_SUBST(GRAM_ERROR_INVALID_PARADYN)
    AC_SUBST(GRAM_ERROR_INVALID_JOBTYPE)
    AC_SUBST(GRAM_ERROR_INVALID_MYJOB)
    AC_SUBST(GRAM_ERROR_BAD_SCRIPT_ARG_FILE)
    AC_SUBST(GRAM_ERROR_ARG_FILE_CREATION_FAILED)
    AC_SUBST(GRAM_ERROR_INVALID_JOBSTATE)
    AC_SUBST(GRAM_ERROR_INVALID_SCRIPT_REPLY)
    AC_SUBST(GRAM_ERROR_INVALID_SCRIPT_STATUS)
    AC_SUBST(GRAM_ERROR_MPI_NOT_SUPPORTED)
    AC_SUBST(GRAM_ERROR_UNIMPLEMENTED)
    AC_SUBST(GRAM_ERROR_TEMP_SCRIPT_FILE_FAILED)
    AC_SUBST(GRAM_ERROR_PROXY_FILE_RELOCATION_FAILED)
    AC_SUBST(GRAM_ERROR_PROXY_FILE_OPEN_FAILED)
    AC_SUBST(GRAM_ERROR_JOB_CANCEL_FAILED)
    dnl Add new GRAM_ERROR codes here
    AC_SUBST(GRAM_ERROR_LAST)

    dnl Assign all of the GRAM_STATE values
    GRAM_JOB_STATE_PENDING=1
    GRAM_JOB_STATE_ACTIVE=2
    GRAM_JOB_STATE_FAILED=4
    GRAM_JOB_STATE_DONE=8
    GRAM_JOB_STATE_SUSPENDED=16
    GRAM_JOB_STATE_ALL=0xFFFFF

    AC_SUBST(GRAM_JOB_STATE_PENDING)
    AC_SUBST(GRAM_JOB_STATE_ACTIVE)
    AC_SUBST(GRAM_JOB_STATE_FAILED)
    AC_SUBST(GRAM_JOB_STATE_DONE)
    AC_SUBST(GRAM_JOB_STATE_SUSPENDED)
    AC_SUBST(GRAM_JOB_STATE_ALL)
])


AC_DEFUN(LAC_LSF_DIR,
[

  if test -d $1 ; then
    LSF_DIRS="$LSF_DIRS $2 $1"
  fi
])
