/******************************************************************************
CIF_Connection_Nexus_UUM.H

Description:

  Connection class for Nexus using UUM (unreliable unordered multicast)

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

#if !defined(CIF_INCLUDE_CIF_CONNECTION_NEXUS_UUM)
#define CIF_INCLUDE_CIF_CONNECTION_NEXUS_UUM 1

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Connection_Nexus.H"


/******************************************************************************
		     Define CIF_Connection_Nexus_UUM class
******************************************************************************/
class
CIF_Connection_Nexus_UUM
: public CIF_Connection_Nexus
{
    protected: virtual
    CIF_Bool
    establish_Connection(
	ARG_IN char *			url,
	ARG_OUT Nexus_Endpoint &	local_comm_endpoint,
	ARG_OUT Nexus_Startpoint &	remote_comm_startpoint,
	ARG_IN int			timeout = -1);

    protected: virtual
    CIF_Bool
    establish_Connection(
	ARG_IN Nexus_Endpoint &		local_ctrl_endpoint,
	ARG_OUT Nexus_Endpoint &	local_comm_endpoint,
	ARG_OUT Nexus_Startpoint &	remote_comm_startpoint,
	ARG_IN int			timeout = -1);
};

#endif /* CIF_INCLUDE_CIF_CONNECTION_NEXUS_UUM */
