/******************************************************************************
Nexus_Timer.C

Description:

  A simple timer class

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "Nexus_Timer.H"
#include <sys/time.h>


/******************************************************************************
			 Class Nexus_Timer definition
******************************************************************************/

Nexus_Timer::Nexus_Timer(
    int					milliseconds)
: time_allotted(milliseconds)
{
    struct timeval			tv;
    
    gettimeofday(&tv, NULL);
    time_started = tv.tv_sec * 1000 + tv.tv_usec / 1000;
}

Nexus_Timer::~Nexus_Timer()
{
}

int
Nexus_Timer::get_Remaining_Time()
{
    int					time_left;
    
    if (time_allotted < 0)
    {
	time_left = -1;
    }
    else
    {
	struct timeval			tv;
	
	gettimeofday(&tv, NULL);
	time_left = time_allotted + time_started
	    - (tv.tv_sec * 1000 + tv.tv_usec / 1000);
	if (time_left < 0)
	{
	    time_left = 0;
	}
    }

    return time_left;
}

